#----------------------------------------------------------------------------
# Root.mk -> ${ROOT}/Makefile
#
# Makefiles for managing a Java project consisting of multiple packages.
# (see ${ROOT}/etc/Makefile.README)
# Daishi Harada (daishi@cs.berkeley.edu)
#----------------------------------------------------------------------------

ROOT = ${shell pwd}
SRC_ROOT = ${ROOT}/src

include ${ROOT}/include/Defs.mk

all:
	cd src; ${MAKE} fullall

full:	name beans all

install:
	cd src; ${MAKE} fullinstall

clean:
	${CLEAN} ${GARBUFT}
	${CLEAN} ${ALLPKGS_FILE}
	cd src; ${MAKE} fullclean

realclean:	clean
	${CLEAN} ${APIDOC_DIR}/*
	${CLEAN} ${CLASS_DIR}/*
	${CLEAN} ${JAR_DIR}/*
	${CLEAN} tmp/*

name:
	cd src; ${MAKE} fullname

beans:
	cd src; ${MAKE} fullbeans

docs:
	find . -name "${PKGNAME_FILE}" -exec cat \{\} > ${TMP_FILE} \;
	sort ${TMP_FILE} > ${ALLPKGS_FILE}
	CLASSPATH=${SRC_ROOT}:${CLASSPATH}; \
	export CLASSPATH; \
	javadoc -d ${APIDOC_DIR} `cat ${ALLPKGS_FILE}`
#	polardoc -d ${APIDOC_DIR} `cat ${ALLPKGS_FILE} | sed -e "s/\./\//g" -e "s/^/src\//g" -e "s/$$/\/*.java/g"`
	cp -R ${ROOT}/etc/images ${APIDOC_DIR}
	${CLEAN} ${TMP_FILE}

jars:	jars-real

jars-real:
	cd src; ${MAKE} jars
