package aima.agents;
import java.applet.*;
import java.awt.*;               // ScrollPane,
import java.awt.event.*;         // New event model.
import java.io.*;                // Object serialization streams.
import java.util.*;
import java.lang.Math;

public class GridApplet extends Applet {

  GridEnvironment environment;
  boolean running = false;
  int delay = 1000;
  Label cellLabel;

  public void init() {
    //{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		//addNotify();
		//resize(430,270);
		//}}

    
    environment = VacuumEnvironment.sample();
    final GridComponent grid = new GridComponent(this, environment, 600, 600);
    
    ActionListener a = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      String command = e.getActionCommand();
      if (command.equals(">")) {
        environment.run(1); grid.repaint(); repaint(); 
        running = false;
      } else if (command.equals(">>")) {
        running = true;
      } else if (command.equals("Stop")) {
        running = false;
      } else if (command.equals("Restart")) {
        environment = (GridEnvironment)AIMA.newOne(environment);
      }
    }
  };

    Panel p = new Panel();
    button(p, a, ">");
    button(p, a, ">>");
    button(p, a, "Stop");
    button(p, a, "Restart");
    p.add(cellLabel = new Label("0,0",java.awt.Label.LEFT));
    ScrollPane pane = new ScrollPane();
    pane.setSize(300, 300);
    pane.add(grid);
    add(p,"North");
    add(pane,"Center");

    // Run when the user says you should be running
    // Unfortunately, when I try this, I get no output
    /*Thread runner = (new Thread() {
      public void run() {
        try {
          for(;;) {
            if (running) environment.run(1);
            sleep(delay); // grid.repaint(); repaint();
          }
        } catch (InterruptedException e) {
          return;
        }
      }
    });

    runner.run();
*/

  }
  
  
  private void button(Panel p, ActionListener a, String label) {
    Button button = new Button(label);
    p.add(button);
    button.addActionListener(a);
    
  }
	//{{DECLARE_CONTROLS
	//}}
}


