package aima.cs.util;

import java.lang.*;
import java.util.*;
// Should clean this up so that this doesn't depend on aima.search;
import aima.search.*;


/**
    Queue adapter that rejects any repeated state.
    add() must be redefined for priority queues to accept
    shorter paths to previously found states.  
*/

public class NoRepeatQueue implements GeneralQueue {

   protected GeneralQueue originalQ;
   protected Hashtable seen;
   protected Boolean placeholder;

   public NoRepeatQueue(GeneralQueue originalQ) {
       this.originalQ = originalQ;

       seen = new Hashtable();
       placeholder = new Boolean(true);
   }


   public void add(Object object) {

      String id = ( (SearchNode) object).getState().toString();

      if (!seen.containsKey(id)) {
          originalQ.add(object);

          seen.put(id, placeholder);
      } 

   }

   public Object removeFront() {
      return originalQ.removeFront(); 
   }

   public boolean isEmpty() {
      return originalQ.isEmpty();
   }

}

