package aima.stat.rv;

/**
  * Root interface which must be implemented by all RV's.
  *
  * Note that the method for sampling is <code>sampleObject()</code>.
  * This is so that more specific types of RV's (e.g., <code>intRV</code>)
  * may have the method <code>sample()</code> return the appropriate type
  * (e.g., <code>int</code> for an <code>intRV</code>.)
  *
  * @author Daishi Harada (daishi@cs.berkeley.edu)
  *
  * @see EDU.Berkeley.cs.aima.stat.rv.intRV
  * @see EDU.Berkeley.cs.aima.stat.rv.doubleRV
  */
public interface RV
{
  public Object sampleObject();
}
