package aima;

/**
  * The Environment interface.
  */
public interface Environment
{
  public abstract void addAgent(Agent agent);
  public abstract void removeAgent(Agent agent);
  public abstract void run();

  /**
    * Specification of AgentManagers.
    * Environments can use this interface to encapsulate
    * the functionality needed to interact with agents.
    */
  public interface AgentManager
  {
    public void givePerceptToAgent(Agent agent, Percept percept);
    public Action getActionFromAgent(Agent agent);
  }

  /**
    * Environments can define what kind of things
    * can exist in them. In particular, Agent Bodies
    * are a kind of Environment.Thing
    */
  public interface Thing
  {      
  }
}
