package aima.util;

import aima.*;
import aima.cs.util.*;

/**
  * The Base Agent.
  *
  * All AIMA Agents will subclass from this class.
  */
public abstract class BaseAgent
  implements Agent
{
  public BaseAgent(Agent.Program program) {
    this.program = program;
  }

  public Action execute(Percept percept) {
    return (program.execute(percept));
  }

  public void setBody(Agent.Body body) {
    this.body = body;
    setupActionPerceptTables();
  }

  public Agent.Body getBody() {
    return (body);
  }

  /**
    * Utility function for selecting actions by name
    */
  protected Action getActionByName(String actionName) {
    return (name2Action.get(actionName));
  }

  private void setupActionPerceptTables() {
    Iterator iter;
    Action action;
    Percept percept;
    iter = (body.getActions()).iterator();
    while (iter.hasNext()) {
      action = (Action)iter.next();
      name2Action.put(action.getName(), action);
    }
    iter = (body.getPercepts()).iterator();
    while (iter.hasNext()) {
      percept = (Percept)iter.next();
      name2Percept.put(percept.getName(), percept);
    }
  }

  protected Agent.Program program
  protected Agent.Body body

  private Table name2Action = new Hashtable();
  private Table name2Percept = new Hashtable();
}
