package aima.util;

public abstract class BeanAgent
  implements PerceptListener
{
  public synchronized void receivePercept(PerceptEvent perceptEvent) {
    action = program.execute(perceptEvent.getPercept());
    // Should add code to send ActionEvent to ActionListeners.
    // For now, using execute should suffice for our simple environments.
  }

  /**
    * "Returns" an ActionEvent by calling back the sender of the
    * PerceptEvent.
    * The source of the PerceptEvent must be a ActionListener.
    */
  public void execute(PerceptEvent perceptEvent) {
    receivePercept(perceptEvent);
    if (perceptEvent.getSource() instanceof ActionListener) {
      ((ActionListener)perceptEvent.getSource()).receiveAction(new ActionEvent(this, action));
    } else {
      // Signal Error
    }
  }

  /**
    * Action taken by the agent.
    */
  protected Action action;

}
