package aima;

public class Environment
  implements ActionListener
{
  /**
    * This exists to fulfill the ActionListener contract,
    * but is null for now. In general, actionEvents will go back
    * to the agentManager for demultiplexing.
    */
  public void receiveAction(ActionEvent actionEvent) {
  }

  /**
    * The agent manager
    */
  protected AgentManager agentManager;

  /**
    * The AgentManager encapsulates the functionality needed
    * for interaction with agents. Note that the AgentManager
    * does not provide an execute(agent, percept) method; this is
    * meant to discourage unnecessary sequentialization of agent
    * execution.
    */
  public interface AgentManager
    extends ActionListener
  {
    public void addAgent(Agent agent);
    public void removeAgent(Agent agent);
    public void setAgentPercept(Agent agent, Percept percept);
    public Action getAgentAction(Agent agent);
  }
}
