package aima.search;

import java.lang.*;
import java.util.*;

/**
   Quick and dirty implementation of priority queue.  Uses
   BinaryPredicate (like JGL) to determine queue order. 
   add() operation is not efficient and should be replaced
   with a standard, efficient, heap implementation.
*/


public class PriorityQueue implements GeneralQueue {

   protected Vector queue;
   protected BinaryPredicate comparator;

   public PriorityQueue(BinaryPredicate comparator) {
       queue = new Vector();
       this.comparator = comparator;
   }

   public void add(Object object) {
      int i;

      for (i=queue.size()-1; i>=0; i--) {
         if (comparator.evaluate(queue.elementAt(i), object)) break;
      }

      queue.insertElementAt(object, i+1);
   }

   public Object removeFront() {

      Object object= queue.lastElement(); 
      queue.removeElementAt(queue.size()-1); 

      return object;
   }

   public boolean isEmpty() {
      return queue.size() == 0;
   }

}

